/**
 * 
 */
package org.springblade.cube.enums;

/**
 * @author wookvn
 *
 */
public interface DbMysqlEnums {

	int BATCH_SIZE = 3000;
	int DEFAULT_MAX_SIZE = 1000000;
	String CHECK_TABLE_DATASIZE_SQL_FORMAT = "select count(*) from (select 1 from %s limit %s) a";
	
	/**
	 * 与{@link ViewColumnTypeEnum}保持一致
	 */
	public enum ColumnType{
		//https://dev.mysql.com/doc/refman/5.7/en/precision-math-decimal-characteristics.html
		NUMBER("decimal(30, 4)"),
		//https://dev.mysql.com/doc/refman/8.0/en/column-count-limit.html
		STRING("varchar(1000)"),
		DATETIME("datetime"),
		BIGINT("bigint");
		
		public String columnType;
		private ColumnType(String columnType) {
			this.columnType = columnType;
		}
	}
	/**
	 * 函数方法
	 */
	enum MethodType{
		DATE_TO_STR("DATE_FORMAT(%s, '%s')"),
		STR_TO_DATE("STR_TO_DATE(%s, '%s')"),
		NUMBER_TO_DATE("STR_TO_DATE(CONCAT(%s, ''), '%s')"),
		JOINT_PERCENT("CONCAT(%s, '%%')");
		
		public String method;
		private MethodType(String method) {
			this.method = method;
		}
	}
	/**
	 *	日期格式化字符串
	 *	与#{link DateFormatEnum}保持一致
	 */
	enum DateTimeFormat{
		yyyy("%Y"),
		yyyyMM("%Y%m"),
		yyyy_MM("%Y-%m"),
		yyyy$MM("%Y/%m"),
		yyyyMMdd("%Y%m%d"),
		yyyy_MM_dd("%Y-%m-%d"),
		yyyy$MM$dd("%Y/%m/%d"),
		yyyyMMddhh$mm$ss("%Y%m%d %H:%i:%S"),
		yyyy_MM_ddhh$mm$ss("%Y-%m-%d %H:%i:%S"),
		yyyy$MM$ddhh$mm$ss("%Y/%m/%d %H:%i:%S"),
		hh("%H"),
		hh$mm("%H:%i"),
		hh$mm$ss("%H:%i:%S");
		
		public String formatPattern;
		private DateTimeFormat(String formatPattern) {
			this.formatPattern = formatPattern;
		}
	}
}
