/**
 * 
 */
package org.springblade.cube.enums;

/**
 * @author wookvn
 *
 */
public interface DbOracleEnums {
	
	int BATCH_SIZE = 4000;
	int DEFAULT_MAX_SIZE = 1000000;
	String CHECK_TABLE_DATASIZE_SQL_FORMAT = "SELECT count(1) FROM %s WHERE ROWNUM <= %s";

	/**
	 * 与{@link ViewColumnTypeEnum}保持一致
	 */
	enum ColumnType{
		NUMBER("NUMBER(30, 4)"),
		STRING("VARCHAR2(1000)"),
		DATETIME("DATE"),
		BIGINT("NUMBER");
		
		public String columnType;
		private ColumnType(String columnType) {
			this.columnType = columnType;
		}
	}
	
	enum MethodType{
		DATE_TO_STR("TO_CHAR(%s, '%s')"),
		STR_TO_DATE("TO_DATE(%s, '%s')"),
		NUMBER_TO_DATE("TO_DATE(TO_CHAR(%s), '%s')"),
		JOINT_PERCENT("TO_CHAR(%s, '%s') || '%%'");
		
		public String method;
		private MethodType(String method) {
			this.method = method;
		}
	}
	
	/**
	 *	日期格式化字符串
	 *	与{@link DateFormatEnum}保持一致
	 */
	enum DateTimeFormat{
		yyyy("yyyy"),
		yyyyMM("yyyyMM"),
		yyyy_MM("yyyy-MM"),
		yyyy$MM("yyyy/MM"),
		yyyyMMdd("yyyyMMdd"),
		yyyy_MM_dd("yyyy-MM-dd"),
		yyyy$MM$dd("yyyy/MM/dd"),
		yyyyMMddhh$mm$ss("yyyyMMdd HH24:mi:ss"),
		yyyy_MM_ddhh$mm$ss("yyyy-MM-dd HH24:mi:ss"),
		yyyy$MM$ddhh$mm$ss("yyyy/MM/dd HH24:mi:ss"),
		hh("HH24"),
		hh$mm("HH24:mi"),
		hh$mm$ss("HH24:mi:ss");
		
		public String formatPattern;
		private DateTimeFormat(String formatPattern) {
			this.formatPattern = formatPattern;
		}
	}
}
