/**
 * 
 */
package org.springblade.cube.enums;

/**
 * @author wookvn
 *
 */
public interface DbSqlServerEnums {
	
	int BATCH_SIZE = 3000;
	int DEFAULT_MAX_SIZE = 1000000;
	String CHECK_TABLE_DATASIZE_SQL_FORMAT = "SELECT rows FROM sysindexes WHERE id = OBJECT_ID('%s') AND indid < 2";

	/**
	 * 与{@link ViewColumnTypeEnum}保持一致
	 */
	enum ColumnType{
		NUMBER("decimal(30, 4)"),
		STRING("varchar(1000)"),
		DATETIME("datetime"),
		BIGINT("bigint");
		
		public String columnType;
		private ColumnType(String columnType) {
			this.columnType = columnType;
		}
	}
	
	enum MethodType{
		DATE_TO_STR("FORMAT(%s, '%s')"),
		STR_TO_DATE("CONVERT(datetime, %s)"),
		NUMBER_TO_DATE("CONVERT(datetime, convert(varchar(50), %s))"),
		JOINT_PERCENT("convert(varchar(50), %s)+'%%'");
		
		public String method;
		private MethodType(String method) {
			this.method = method;
		}
	}
	
	/**
	 *	日期格式化字符串
	 * 	与#{link DateFormatEnum}保持一致
	 */
	enum DateTimeFormat{
		yyyy("yyyy"),
		yyyyMM("yyyyMM"),
		yyyy_MM("yyyy-MM"),
		yyyy$MM("yyyy/MM"),
		yyyyMMdd("yyyyMMdd"),
		yyyy_MM_dd("yyyy-MM-dd"),
		yyyy$MM$dd("yyyy/MM/dd"),
		yyyyMMddhh$mm$ss("yyyyMMdd hh:mm:ss"),
		yyyy_MM_ddhh$mm$ss("yyyy-MM-dd hh:mm:ss"),
		yyyy$MM$ddhh$mm$ss("yyyy/MM/dd hh:mm:ss"),
		hh("hh"),
		hh$mm("hh:mm"),
		hh$mm$ss("hh:mm:ss");
		
		public String formatPattern;
		private DateTimeFormat(String formatPattern) {
			this.formatPattern = formatPattern;
		}
	}
}
