/**
 * 
 */
package org.springblade.cube.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.springblade.cube.model.CubeData;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;

/**
 * @author wookvn
 *
 */
public interface CubeDataMapper extends BaseMapper<CubeData> {

	@Select("select * from cube_data where JSON_CONTAINS(cube_table_names, JSON_OBJECT('tableName', #{value}))")
	public List<CubeData> listByTableName(String tableName);
	
	@Select({
		"select distinct c.workspace_id from cube_data c",
		"left join cube_data_permission a on c.id = a.cube_data_id",
		"left join data_permission_user b on a.data_perm_id = b.data_perm_id",
		"where b.user_id = #{userId} or c.create_user_id = #{userId} or c.public_status = 1"
	})
	public List<Integer> workspaceIdList(@Param("userId") Long userId);
	
}
