/**
 * 
 */
package org.springblade.cube.model;

import java.io.Serializable;

import org.springblade.cube.enums.ViewColumnTypeEnum;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @author wookvn
 *
 */
@Data
@ApiModel("文件结构体Model")
public class FileStructure implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@ApiModelProperty("字段名")
	private String columnName;
	
	@ApiModelProperty("字段类型")
	private ViewColumnTypeEnum columnType;
	
	@ApiModelProperty("注释")
	private String comment;
	
	@ApiModelProperty("Excel列索引")
	private int columnIndex;
	
	@ApiModelProperty("是否主键")
	private boolean primaryKey;

	/**
	 * @param columnName
	 * @param columnType
	 * @param comment
	 * @param columnIndex
	 */
	public FileStructure(String columnName, ViewColumnTypeEnum columnType, String comment, int columnIndex) {
		super();
		this.columnName = columnName;
		this.columnType = columnType;
		this.comment = comment;
		this.columnIndex = columnIndex;
	}
	
	public FileStructure(String columnName, ViewColumnTypeEnum columnType, String comment, boolean primaryKey) {
		super();
		this.columnName = columnName;
		this.columnType = columnType;
		this.comment = comment;
		this.primaryKey = primaryKey;
	}

	/**
	 * 
	 */
	public FileStructure() {
		super();
	}
}
