/**
 * 
 */
package org.springblade.cube.utils;

import org.springblade.cube.enums.DbClickHouseEnums;
import org.springblade.cube.enums.DbMysqlEnums;
import org.springblade.cube.enums.DbOracleEnums;
import org.springblade.cube.enums.DbSqlServerEnums;
import org.springblade.report.enums.DsTypeEnum;

/**
 * @author wookvn
 *
 */
public class MultiDsSelectUtils {

	/**
	 * 执行MethodType的方法
	 * @param dsType
	 * @param enumName
	 * @param values
	 * @return
	 */
	public static String invokeEnumMethodType(DsTypeEnum dsType, String enumName, Object... values) {
		switch (dsType) {
			case clickhouse: {
				return String.format(DbClickHouseEnums.MethodType.valueOf(enumName).method, values);
			}
			case mysql: {
				return String.format(DbMysqlEnums.MethodType.valueOf(enumName).method, values);
			}
			case oracle: {
				return String.format(DbOracleEnums.MethodType.valueOf(enumName).method, values);
			}
			case sqlserver: {
				return String.format(DbSqlServerEnums.MethodType.valueOf(enumName).method, values);
			}
			default: {
			}
		}
		return null;
	}
	
	/**
	 * 获取DateTimeFormat的值
	 * @param dsType
	 * @param enumName
	 * @return
	 */
	public static String getEnumDateTimeFormat(DsTypeEnum dsType, String enumName) {
		switch (dsType) {
			case clickhouse: {
				return DbClickHouseEnums.DateTimeFormat.valueOf(enumName).formatPattern;
			}
			case mysql: {
				return DbMysqlEnums.DateTimeFormat.valueOf(enumName).formatPattern;
			}
			case oracle: {
				return DbOracleEnums.DateTimeFormat.valueOf(enumName).formatPattern;
			}
			case sqlserver: {
				return DbSqlServerEnums.DateTimeFormat.valueOf(enumName).formatPattern;
			}
			default: {
			}
		}
		return null;
	}
}
