/**
 * 
 */
package org.springblade.resouces;

import java.util.List;

import org.springblade.bi.client.DynamicDataSourceClient;
import org.springblade.bi.client.form.BaseDsForm;
import org.springblade.bi.client.form.PageDsForm;
import org.springblade.bi.client.model.PageModel;
import org.springblade.cube.service.DynamicTableService;
import org.springblade.report.entity.ReportDatasource;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson2.JSONObject;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;

import cn.hutool.core.collection.CollectionUtil;

/**
 * @author wookvn
 *
 */
@RestController
public class DynamicDataSourceResource implements DynamicDataSourceClient{
	
	@Autowired
	private DynamicTableService dynamicTableService;

	@Override
	public List<JSONObject> list(BaseDsForm dsForm) {
		ReportDatasource reportDatasource = new ReportDatasource();
		reportDatasource.setPoolName(dsForm.getPoolName());
		return dynamicTableService.selectListForJSONObject(reportDatasource, dsForm.getSql());
	}

	@Override
	public PageModel<JSONObject> page(PageDsForm dsForm) {
		ReportDatasource reportDatasource = new ReportDatasource();
		reportDatasource.setPoolName(dsForm.getPoolName());
		Page<?> pageParam = new Page<>(dsForm.getCurrent(), dsForm.getSize());
		IPage<JSONObject> page = dynamicTableService.selectPageForJSONObject(pageParam, reportDatasource, dsForm.getSql());
		PageModel<JSONObject> pageResult = new PageModel<>();
		if(page != null && CollectionUtil.isNotEmpty(page.getRecords())) {
			pageResult.setRecords(page.getRecords());
			pageResult.setCurrent(page.getCurrent());
			pageResult.setPages(page.getPages());
			pageResult.setTotal(page.getTotal());
			pageResult.setSize(page.getSize());
		}
		return pageResult;
	}

	@Override
	public JSONObject getOne(BaseDsForm dsForm) {
		ReportDatasource reportDatasource = new ReportDatasource();
		reportDatasource.setPoolName(dsForm.getPoolName());
		return dynamicTableService.selectOneForJSONObject(reportDatasource, dsForm.getSql());
	}

	@Override
	public void execute(BaseDsForm dsForm) {
		ReportDatasource reportDatasource = new ReportDatasource();
		reportDatasource.setPoolName(dsForm.getPoolName());
		dynamicTableService.executeSql(reportDatasource, dsForm.getSql());
	}

	
}