/**
 * 
 */
package org.springblade.bi.client;

import org.springblade.bi.client.factory.CubeDataClientFallbackFactory;
import org.springblade.bi.client.model.CubeDataModel;
import org.springblade.common.openfeign.OpenFeignConstants;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;

/**
 * @author wookvn
 * 	
 * 	数据集Client
 */
@RequestMapping(OpenFeignConstants.BI_SERVICE + "/cube")
@FeignClient(contextId = "cubeDataClient", 
	value = OpenFeignConstants.BI_SERVICE, 
	fallbackFactory = CubeDataClientFallbackFactory.class)
public interface CubeDataClient {

	@GetMapping("/info/{id}")
	public CubeDataModel getById(@PathVariable Integer id);
}
