/**
 * 
 */
package org.springblade.bi.client;

import org.springblade.bi.client.factory.DataSourceClientFallbackFactory;
import org.springblade.bi.client.model.DataSourceModel;
import org.springblade.common.openfeign.OpenFeignConstants;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;

/**
 * @author wookvn
 *
 *	数据源
 */
@RequestMapping(OpenFeignConstants.BI_SERVICE + "/datasource")
@FeignClient(contextId = "dataSourceClient", 
	value = OpenFeignConstants.BI_SERVICE, 
	fallbackFactory = DataSourceClientFallbackFactory.class)
public interface DataSourceClient {

	@GetMapping("/info/{id}")
	public DataSourceModel getById(@PathVariable Integer id);
}
