/**
 * 
 */
package org.springblade.bi.client;

import java.util.List;

import org.springblade.bi.client.factory.DynamicDataSourceClientFallbackFactory;
import org.springblade.bi.client.form.BaseDsForm;
import org.springblade.bi.client.form.PageDsForm;
import org.springblade.bi.client.model.PageModel;
import org.springblade.common.openfeign.OpenFeignConstants;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import com.alibaba.fastjson2.JSONObject;

/**
 * @author wookvn
 *
 */
@RequestMapping(OpenFeignConstants.BI_SERVICE + "/dynamicDsClient")
@FeignClient(contextId = "dynamicDsClient", 
	value = OpenFeignConstants.BI_SERVICE, 
	fallbackFactory = DynamicDataSourceClientFallbackFactory.class)
public interface DynamicDataSourceClient {

	/**
	 * 查询列表
	 * @param dsForm
	 * @return
	 */
	@PostMapping("/list")
	public List<JSONObject> list(@RequestBody BaseDsForm dsForm);
	
	/**
	 * 分页查询
	 * @param dsForm
	 * @return
	 */
	@PostMapping("/page")
	public PageModel<JSONObject> page(@RequestBody PageDsForm dsForm);
	
	/**
	 * 查询单个
	 * @param dsForm
	 * @return
	 */
	@PostMapping("/getOne")
	public JSONObject getOne(@RequestBody BaseDsForm dsForm);
	
	/**
	 * 执行SQL
	 * @param dsForm
	 */
	@PostMapping("/exec")
	public void execute(@RequestBody BaseDsForm dsForm);
	
}